function downloadFile( url, localfilename )
{
	try
	{
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, 
			function onFileSystemSuccess(fileSystem) 
			{
				fileSystem.root.getFile(
					"dummy.html", {create: true, exclusive: false}, 
					function gotFileEntry(fileEntry) 
					{
						var sPath = fileEntry.fullPath.replace("dummy.html","");
						var fileTransfer = new FileTransfer();
						fileEntry.remove();

						fileTransfer.download(
							url,
							sPath + localfilename,
							function(theFile) 
							{
								console.log("download complete: " + theFile.toURI());
								showLink(theFile.toURI());
							},
							function(error) 
							{
								console.log("download error source " + error.source);
								console.log("download error target " + error.target);
								console.log("upload error code: " + error.code);
							}
						);
					}, 
					fail
				);
			}, 
			fail
		);
	}
	catch(e)
	{
		dalert('download file not done:'+url);
	}
};

// document.append( "<img src="+sPath + filename+"/>" );

/*
http://community.phonegap.com/nitobi/topics/download_remote_image_display_when_not_connected_to_internet

First we create the folder we want to store the images in on the filesystem of the device. This would look something like: 
window.requestFileSystem( 
LocalFileSystem.PERSISTENT, 
0, 
function(fileSystem){ 
// Create the folder 
fileSystem.root.getDirectory(myFolderName, {create:true, exclusive:false}, function (folder){}); 
} 
); 

After that we download the image using the FileTransfer plugin and store it on the filesystem. This would look something like: 
ft = new FileTransfer(); 
ft.download(encodeURI(url), myFolderName, callback) 

For displaying the image you can do something like: 
$('#myDiv').css('background-image', 'url(\'' + myFolderName + '/' + imageName+ '\')'); 
*/
