var m_current_pagename = "";
var m_navigate_callback_on_leaving_page = null; // Any page can set this if they want a callback as the page is about to disappear.  Useful for clearing callbacks


$.fn.scrollView = function () {
    return this.each(function () {
        $('html, body').animate({
            scrollTop: $(this).offset().top-80
        }, 1000);
    });
}


function isPhoneGap() 
{
	if(window.cordova || window.PhoneGap || window.phonegap)
	{
		// Potentially phonegap
		// Check iOS/Android
		if( (/^file:\/{3}[^\/]/i.test(window.location.href)) && (/ios|iphone|ipod|ipad|android/i.test(navigator.userAgent)) )
		{
			return true;
		}
		else
		{
			// Check WP8  x-wmapp0:www/index.html
			var test = /^x-wmapp0:/.test(window.location.href);
			return test;
		}
	}
}


function back()
{
	//send_page_leaving_message("from back", m_current_pagename);
	window.history.back();

}

// Fire an event that we're exiting the page so any tidy up code can be done
function send_page_leaving_message( called_from_location, page_leaving_name ) 
{
	//$( "#container" ).trigger( "page_leaving" );
	$(document).trigger( "page_leaving" );
}

/*
// listen for page_leave event
document.addEventListener("page_leave", function page_leave_handler(e)
	{
		LogEvent(
			"Event subscriber on "+e.currentTarget.nodeName+", "
			+e.detail.time.toLocaleString()+": "+e.detail.message
		);
	}, false);
}
*/


// Instructions to show only on the first time the page is loaded
// Instructions text 
// optional_pagename - (optional) so each page is unique
function navigate_show_instructions( instructions, optional_pagename )
{
	if( !m_disableinstructions )
	{
		if( instructions != null )
		{
			if( instructions.length > 0 )
			{
				var optional_pagename;
				if( optional_pagename == null )
				{
					pagename = m_current_pagename;
				}
				else
				{
					pagename = optional_pagename;
				}
				if( is_first_run( pagename + "_instructions" ) || m_debug_always_show_instructions )
				{
					showalert(localise_text('Instructions'), localise_text(instructions) );
				}
			}
		}
	}
}

function is_first_run( unique_pagename_id )
{
	var key = pagename+"_key";
	if( get_localstore( key, "notyet" ) == "notyet" )
	{
		//dalert( "Showing with value:"+get_localstore( key, "whoknows" ));
		set_localstore( key, "shown_already" );
		return true;
	}
	return false;
}


function navigate_setup_back_button_handler()
{
	document.addEventListener("backbutton", function(e){
	   if((window.location.hash=="mainmenu") || (window.location.hash=="") )
	   {
		   e.preventDefault();
		   FlurryAgent.endSession();
		   navigator.app.exitApp();
	   }
	   else 
	   {
		   //navigator.app.backHistory()
		   back();
	   }
	}, false);
}


// This function is only valid after ondevice has been called
function is_running_via_browser()
{
	/*if( m_has_loaded )
	{

		dalert("g_running_cordova =" +g_running_cordova);
		return g_running_cordova;
	}
	else
	{
		alert( 'Checking if running in app before having a chance to detected ondeviceready' );
	}*/

	if( m_has_loaded )
	{
		// sat added code from http://slavik.meltser.info/phonegap-detect-if-the-application-runs-on-mobile-or-browser-using-javascript-before-the-deviceready-and-document-ready-events-are-triggered/

		if ( isPhoneGap() ) 
		{
		    dalertonce("Running on PhoneGap!" + (window.cordova || window.PhoneGap || window.phonegap) );
		    return false;
		} 
		else 
		{
			if( !m_is_website )
			{
				// Warn since we're on a phone
				dalertonce("Running NOT on PhoneGap!");
			}
		    return true;
		    //g_running_cordova = false;
		}
		//return g_running_cordova;
	}
	else
	{
		//alert( 'Checking if running in app before having a chance to detected ondeviceready' );
	}


}


// Used to navigate to a new page.  Pass the HTML to use
function navigate_to_page(pagename)
{
	//send_page_leaving_message("from navigate_to_page", m_current_pagename);
	window.location.hash = pagename;
}


// Opens the external link
function navigate_to_external_page(url, shortname)
{

	if( !is_network_to_server_available() )
	{
		showalert('No network', 'You appear to be working offline.  You can only view this content with a network connection.');
	}
	else
	{
		var question_to_ask = 'This will navigate you to the '+shortname+' website page and leave this app, would you like to do this now?';
		if( is_running_via_browser() == false )
		{
			navigator.notification.confirm( question_to_ask,
				function(button_index)
				{
					if( button_index == 2 )
					{
						send_page_leaving_message("from navigate_to_external_page", m_current_pagename);
					
						// Uses plugin approach for iOS transition
						//https://www.facebook.com/duraflex?ref=br_tf
						window.open(url, "_system" );
					}
				},
				'Leave app?',
				"No thanks,Yes please"
			);
		}
		else
		{
			// Browser approach
			if( confirm( question_to_ask) )
			{

				location.href =url; //works but back button is now removed // fb works

			}
		}
	}
}



// You can select a page by doing a href to #mypage.html  and it will now load mypage.html
function on_hash_changed(event)
{
    allow_refresh_if_resynced();
	send_page_leaving_message( "from on_hash_changed", m_current_pagename );
	_change_page(event, false );
} 



// Called when data changes or language changes
function app_reload_current_page()
{
	send_page_leaving_message( "from app_reload_current_page", m_current_pagename );

	_change_page(null, true );
}

function navigate_set_callback_on_pageleave( callback )
{
	m_navigate_callback_on_leaving_page = callback;
}

// Internal function to change a page
function _change_page(event, is_reloading_same_page)
{
	try
	{
		var	hash = window.location.hash;

		var section = hash.split("?");
		var pagename = section[0].substr(1);
		var params = {};
		if( section.length > 1 )
		{
			params['p']=section[1];
		}
		var flurrypagename = pagename;
		// Don't record mainmenu page views
		if( flurrypagename != "" )
		{
			FlurryAgent.logEvent("view_"+pagename, params );
		}
		
		if( !get_is_page_loading() )
		{

			// Async load the page in. When it's loaded call the on_about_to_display() for this new item
			lock_page_changes();
			
			// Stop any callbacks to avoid memory leaks and script errors as they're unloaded
			if( m_navigate_callback_on_leaving_page != null )
			{
				m_navigate_callback_on_leaving_page();
				m_navigate_callback_on_leaving_page = null;
			}

			// take the url params to be easily accessible so hello.html?blah=apple&colour=blue  we get ma_parameters['blah'] = apple
			ma_parameters = [];
			if( section.length > 1 )
			{
				var parameters_text = section[1];
				var parameters_array = parameters_text.split("&");
				//alert("Found params:"+parameters_array.length);
				for( var counter = 0; counter < parameters_array.length; counter++ )
				{
					var parameter = parameters_array[ counter ];
					var array_components = parameter.split("=");
					if(array_components.length == 2)
					{
						ma_parameters[array_components[0]] = array_components[1];
					}	
					else
					{
						alert("Malformed param, was expecting a=b:"+parameter);
					}
				}
			}
			
			// Make sure we have at least one HTML file to navigate to
			if( ( pagename == "" ) || 
				( pagename == null ) )
			{
				pagename = "mainmenu.html";
			}
			
			// After any page that is not the main menu has been shown set this to false.
			if( pagename != "mainmenu.html" )
			{
				g_main_menu_first_time_app_run = false;
			}
			
			if( is_running_via_browser() )
			{
			
				// we are in a browser to never try to load from the local filestore
				ajax_load_from_bundle(pagename, is_reloading_same_page);
			}
			else
			{
				readFile( pagename, function on_success(response)
					 {
						if( response.length == 0 )
						{
							// This means a 0 byte file has been uploaded so try to use the bundle instead
							// Not found so load from bundle if possible
							dalert( 'local file 0 bytes.. loading bundle file');
							ajax_load_from_bundle(pagename, is_reloading_same_page);
							
						}
						else
						{
//alert("SR: loaded locally"+pagename );
							dalert( "Loaded a locally downloaded page of length "+response.length );
							_showpage( pagename, response, is_reloading_same_page );
						}
					 },
					 function on_error(filename)
					 {
						// Not found so load from bundle if possible (NORMAL ROUTE HERE)
						//alert( 'local file not found.. loading bundle file');
						ajax_load_from_bundle(pagename, is_reloading_same_page);
					 }
				);
			}
		}
		else
		{
			dalert( "Changing page requested but already loading" );
			unlock_page_changes();
		}
	}
	catch( e )
	{
		dalert( "There was an error while changing page\n"+e.message );
	}
}



// Called when a local file named this couldn't be found
function ajax_load_from_bundle(pagename, is_reloading_same_page)
{
	var pagename_safe  = pagename.replace( /x-wmapp0:\/\//, "" );

	$.ajax(
		{
			url:pagename_safe,
			context: document.body,
			success: function(response)
			{
			
				if( response == null )
				{
					dalert( "Null response on load" );
				}

				_showpage( pagename, response, is_reloading_same_page );           // unlock_page_changes();// This is now done in pageslider animation callback
			},
			error: function(response)
			{
				dalert( "Page not found: "+response );
				unlock_page_changes();
			}
		}
	);
}


// Given the HTML this goes to convert the html text to DOM elements
function _showpage( pagename, htmltouse, is_reloading_same_page )
{
stu_alert("SR:_showpage1");
	if( is_reloading_same_page )
	{
		m_slider.clearCurrentPages;
	}
	//scroll_to_top();

	//SR: get_local_path(
	get_local_path_for_htmlelement(
		function callback(localpath)
		{
		
			htmltouse = htmltouse.replace( "%LOCALFILE%", localpath );
//alert( 'SR: searching here:'+localpath);
			if( m_debug && m_debug_verify_html )
			{
				var bracket_left = (htmltouse.split("(").length - 1);
				var bracket_right = (htmltouse.split(")").length - 1);
				var brace_left = (htmltouse.split("{").length - 1);
				var brace_right = (htmltouse.split("}").length - 1);
				var quotes = (htmltouse.split('"').length - 1);
				
				if( bracket_left != bracket_right )
				{
					dalert( 'Left and Right brackets {} mismatch, check HTML code for '+pagename+'.  Found left:'+bracket_left+' right:'+bracket_right );
				}
				if( brace_left != brace_right )
				{
					dalert( 'Left and Right braces () mismatch, check HTML code for '+pagename+'.  Found left:'+brace_left+' right:'+brace_right );
				}
				
				if( (quotes & 1) == 1 )
				{
					dalert( 'Found an odd number of quotes. Count:'+quotes );
				}
				
			}
			// Store the pagename as used by instructions
			m_current_pagename = pagename;
			if( is_reloading_same_page )
			{
				m_slider.reloadPage( pagename, htmltouse );
			}
			else
			{
				m_slider.slidePage( pagename, htmltouse );
			}
		}
	);
}



// Scrolls the window to the top
function scroll_to_top()
{
	window.scrollTo( 0, 0 );
}

function navigator_set_title( title )
{
	$('#navigator_title').fadeTo( "slow" , 0.0, function onfadecompleted()
		{
			$('#navigator_title').html(title);
			$('#navigator_title').fadeTo( "slow" , 1.0);			
		} 
	);

}